/* ---------------------------------------------------------------------------
                           Nullsoft Database Engine
                             --------------------
                        codename: Near Death Experience
--------------------------------------------------------------------------- */

/* ---------------------------------------------------------------------------

 All Purposes Functions

--------------------------------------------------------------------------- */

#include <stdio.h>
#include <string.h>
#include "NDE.h"

//---------------------------------------------------------------------------
int AllocNewPos(VFILE *Handle)
{
Vfseek(Handle, 0, SEEK_END);
return Vftell(Handle);
}

//---------------------------------------------------------------------------
Field *TranslateObject(unsigned char Type, Table *tbl)
{
Field *O=NULL;
switch (Type)
  {
  case FIELD_COLUMN:
    O = new ColumnField();
    break;
  case FIELD_INDEX:
    O = new IndexField();
    break;
  case FIELD_STRING:
    O = new StringField();
    break;
  case FIELD_INTEGER:
    O = new IntegerField();
    break;
  case FIELD_DATETIME:
    O = new DateTimeField();
    break;
  case FIELD_LENGTH:
    O = new LengthField();
    break;
  default:
#ifdef WIN32
    if (!tbl->HasErrors()) {
      MessageBox(NULL, "Your database has been corrupted!\n\nNDE will try to continue, but some of the data may be lost :(", "Database Error", 0);
    }
#else
    printf("NDE Error: unknown field type encountered\n");
#endif
    tbl->IncErrorCount();
    O = new Field();
           break;
  }
return O;
}

//---------------------------------------------------------------------------
char *stristr(char *s1, char *s2)
{
char *p;
for (p=s1;*p;p++)
    if (!strnicmp(p, s2, strlen(s2)))
      return p;
return NULL;
}

//---------------------------------------------------------------------------
char *memmem(char *a, char *b, int s, int l)
{
int n=s-l;
while (n--)
  {
  if (!memcmp(a, b, l))
    return a;
  a++;
  }
return NULL;
}

//---------------------------------------------------------------------------
int mystricmp(char *a, char *b)
{
int r;
if (!a && !b) return 0;
if (!a && b) return 1;
if (!b) return -1;
r = stricmp(a,b);
return min(max(r, -1), 1);
}

