/* ---------------------------------------------------------------------------
                           Nullsoft Database Engine
                             --------------------
                        codename: Near Death Experience
--------------------------------------------------------------------------- */

/* ---------------------------------------------------------------------------

 Database Class

--------------------------------------------------------------------------- */

#include <stdio.h>
#include <memory.h>
#include <string.h>
#include "NDE.h"

#ifdef WIN32
CRITICAL_SECTION Critical;
#endif

//---------------------------------------------------------------------------
Database::Database()
{
hInstance = (HINSTANCE)0;
#ifdef WIN32
InitializeCriticalSection(&Critical);
#endif
}

//---------------------------------------------------------------------------
Database::Database(HINSTANCE hinst)
{
hInstance = hinst;
#ifdef WIN32
InitializeCriticalSection(&Critical);
#endif
}

//---------------------------------------------------------------------------
Database::~Database()
{
#ifdef WIN32
DeleteCriticalSection(&Critical);
#endif
}

//---------------------------------------------------------------------------
void Database::SetInstance(HINSTANCE inst) {
  hInstance = inst;
}

HINSTANCE Database::GetInstance() {
  return hInstance;
}

//---------------------------------------------------------------------------
Table *Database::OpenTable(char *TableName, char *IdxName, BOOL Create, BOOL Cached)
//char *tablefn, char*indexfn, BOOL create)
{
Table *table = new Table(TableName, IdxName, Create, this, Cached);
if (table)
  {
  if (table->Open())
    return table;
  table->Close();
  }
return NULL;
}

//---------------------------------------------------------------------------
void Database::CloseTable(Table *table)
{
if (table)
  {
  table->Close();
  delete table;
  }
}
