#include "NDE.h"

#ifndef WIN32

#include <time.h>

void clear_stdin(void) {
  char thrash[80];
  fgets(thrash, 79, stdin);
}

void CopyFile(const char *filename, const char *destfilename, BOOL failifexists) {
  if (!access(destfilename, 0) && failifexists) return;
  FILE *fin = fopen( filename, "rb" );
  if (!fin) return;
  FILE *fout = fopen( destfilename, "wb" );
  if (!fout) return;
  int bytes;
  char buf[32768];
  while( bytes = fread( buf, 1, 32768, fin ) )
    fwrite( buf, 1, bytes, fout );
  fclose( fin );
  fclose( fout );
}

void DeleteFile(const char *filename) {
  unlink(filename);
}

// not really the same as win32's but fine for our use here
BOOL MoveFile(const char *filename, const char *destfilename) {
  if (!access(destfilename, 0)) unlink(destfilename);
  if (!access(destfilename, 0)) return FALSE;
  CopyFile(filename, destfilename, 0);
  if (!access(destfilename, 0)) {
    unlink(filename);
    return TRUE;
  }
  return FALSE;
}

void Sleep(int ms) {
  if (ms != 0) {
    struct timespec ts = { 0, 0 };
    ts.tv_sec = ms / 1000;
    ts.tv_nsec = (ms % 1000) * 1000000;
    nanosleep(&ts, NULL);
  }
}

#endif

